/*
 * Swagger Petstore
 *
 * This is a sample Petstore server.  You can find out more about Swagger at [http://swagger.io](http://swagger.io) or on [irc.freenode.net, #swagger](http://swagger.io/irc/). 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: apiteam@swagger.io
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace IO.Swagger.Models
{ 
    /// <summary>
    /// Business Term: Scheme Member Definition: Information about a Member of the Scheme. Purpose: To have enough information to be able to produce a Statement of Account indicating premium due.
    /// </summary>
    [DataContract]
    public partial class ValMemberChoice1 : IEquatable<ValMemberChoice1>
    { 
        /// <summary>
        /// Business Term: Date Of Birth Definition: The date of birth of the member. Purpose: To be able to uniquely identify a member within a scheme.
        /// </summary>
        /// <value>Business Term: Date Of Birth Definition: The date of birth of the member. Purpose: To be able to uniquely identify a member within a scheme.</value>
        [Required]
        [DataMember(Name="val_date_of_birth")]
        public DateTime? ValDateOfBirth { get; set; }

        /// <summary>
        /// Business Term: Leaving Date Definition: The date the member left/is due to leave the scheme. Purpose: To identify those members that have left or are due to leave the scheme. To be able to calculate the benefit insured/premium payable in respect of the member/category.
        /// </summary>
        /// <value>Business Term: Leaving Date Definition: The date the member left/is due to leave the scheme. Purpose: To identify those members that have left or are due to leave the scheme. To be able to calculate the benefit insured/premium payable in respect of the member/category.</value>
        [DataMember(Name="val_leaving_date")]
        public DateTime? ValLeavingDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ValMemberChoice1 {\n");
            sb.Append("  ValDateOfBirth: ").Append(ValDateOfBirth).Append("\n");
            sb.Append("  ValLeavingDate: ").Append(ValLeavingDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            return obj.GetType() == GetType() && Equals((ValMemberChoice1)obj);
        }

        /// <summary>
        /// Returns true if ValMemberChoice1 instances are equal
        /// </summary>
        /// <param name="other">Instance of ValMemberChoice1 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValMemberChoice1 other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    ValDateOfBirth == other.ValDateOfBirth ||
                    ValDateOfBirth != null &&
                    ValDateOfBirth.Equals(other.ValDateOfBirth)
                ) && 
                (
                    ValLeavingDate == other.ValLeavingDate ||
                    ValLeavingDate != null &&
                    ValLeavingDate.Equals(other.ValLeavingDate)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                var hashCode = 41;
                // Suitable nullity checks etc, of course :)
                    if (ValDateOfBirth != null)
                    hashCode = hashCode * 59 + ValDateOfBirth.GetHashCode();
                    if (ValLeavingDate != null)
                    hashCode = hashCode * 59 + ValLeavingDate.GetHashCode();
                return hashCode;
            }
        }

        #region Operators
        #pragma warning disable 1591

        public static bool operator ==(ValMemberChoice1 left, ValMemberChoice1 right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(ValMemberChoice1 left, ValMemberChoice1 right)
        {
            return !Equals(left, right);
        }

        #pragma warning restore 1591
        #endregion Operators
    }
}
